osgDB::IsAVectorSerializer< C > Class Template Reference

`#include <Serializer>`

Inheritance diagram for osgDB::IsAVectorSerializer< C >:

## Public Types

typedef C::value_type | ValueType
typedef C::const_iterator | ConstIterator
Public Types inherited from osgDB::BaseSerializer

enum

Type {
RW_UNDEFINED = 0 , RW_USER , RW_OBJECT , RW_IMAGE ,
RW_LIST , RW_BOOL , RW_CHAR , RW_UCHAR ,
RW_SHORT , RW_USHORT , RW_INT , RW_UINT ,
RW_FLOAT , RW_DOUBLE , RW_VEC2F , RW_VEC2D ,
RW_VEC3F , RW_VEC3D , RW_VEC4F , RW_VEC4D ,
RW_QUAT , RW_PLANE , RW_MATRIXF , RW_MATRIXD ,
RW_MATRIX , RW_GLENUM , RW_STRING , RW_ENUM ,
RW_VEC2B , RW_VEC2UB , RW_VEC2S , RW_VEC2US ,
RW_VEC2I , RW_VEC2UI , RW_VEC3B , RW_VEC3UB ,
RW_VEC3S , RW_VEC3US , RW_VEC3I , RW_VEC3UI ,
RW_VEC4B , RW_VEC4UB , RW_VEC4S , RW_VEC4US ,
RW_VEC4I , RW_VEC4UI , RW_BOUNDINGBOXF , RW_BOUNDINGBOXD ,
RW_BOUNDINGSPHEREF , RW_BOUNDINGSPHERED , RW_VECTOR , RW_MAP
}

enum | Usage { READ_WRITE_PROPERTY = 1 , GET_PROPERTY = 2 , SET_PROPERTY = 4 , GET_SET_PROPERTY = GET_PROPERTY | SET_PROPERTY }

## Public Member Functions

| IsAVectorSerializer (const char *name, BaseSerializer::Type elementType, unsigned int numElementsOnRow)
virtual const std::string & | getName () const
virtual unsigned int | size (const osg::Object &obj) const
virtual void | resize (osg::Object &obj, unsigned int numElements) const
virtual void | reserve (osg::Object &obj, unsigned int numElements) const
virtual void | clear (osg::Object &obj) const
virtual void | addElement (osg::Object &obj, void *ptr) const
virtual void | insertElement (osg::Object &obj, unsigned int index, void *ptr) const
virtual void | setElement (osg::Object &obj, unsigned int index, void *ptr) const
virtual void * | getElement (osg::Object &obj, unsigned int index) const
virtual const void * | getElement (const osg::Object &obj, unsigned int index) const
virtual bool | read (InputStream &is, osg::Object &obj)
virtual bool | write (OutputStream &os, const osg::Object &obj)
Public Member Functions inherited from osgDB::VectorBaseSerializer
| VectorBaseSerializer (BaseSerializer::Type elementType, unsigned int elementSize)
Type | getElementType () const
unsigned int | getElementSize () const
Public Member Functions inherited from osgDB::BaseSerializer
| BaseSerializer (int usage)
virtual bool | set (osg::Object &, void *)
virtual bool | get (const osg::Object &, void *)
virtual IntLookup * | getIntLookup ()
void | setUsage (int usage)
int | getUsage () const
void | setUsage (bool hasGetter, bool hasSetter)
bool | supportsReadWrite () const
bool | supportsGetSet () const
bool | supportsGet () const
bool | supportsSet () const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
virtual void | setThreadSafeRefUnref (bool)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Public Attributes

std::string | _name
unsigned int | _numElementsOnRow

## Additional Inherited Members

Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const
Protected Attributes inherited from osgDB::VectorBaseSerializer
Type | _elementType
unsigned int | _elementSize
Protected Attributes inherited from osgDB::BaseSerializer
int | _firstVersion
int | _lastVersion
int | _usage
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Member Typedef Documentation

## ConstIterator

template<typename C>

typedef C::const_iterator osgDB::IsAVectorSerializer< C >::ConstIterator

## ValueType

template<typename C>

typedef C::value_type osgDB::IsAVectorSerializer< C >::ValueType

## Constructor & Destructor Documentation

## IsAVectorSerializer()

template<typename C>

osgDB::IsAVectorSerializer< C >::IsAVectorSerializer | ( | const char * | name,
|  | BaseSerializer::Type | elementType,
|  | unsigned int | numElementsOnRow )

inline

References _name, _numElementsOnRow, and osgDB::VectorBaseSerializer::VectorBaseSerializer().

## Member Function Documentation

## addElement()

template<typename C>

virtual void osgDB::IsAVectorSerializer< C >::addElement | ( | osg::Object & | obj,
|  | void * | ptr ) const

inline virtual

Reimplemented from osgDB::VectorBaseSerializer.

References OBJECT_CAST.

## clear()

template<typename C>

virtual void osgDB::IsAVectorSerializer< C >::clear | ( | osg::Object & | obj | ) | const

inline virtual

Reimplemented from osgDB::VectorBaseSerializer.

References OBJECT_CAST.

## getElement() [1/2]

template<typename C>

virtual const void * osgDB::IsAVectorSerializer< C >::getElement | ( | const osg::Object & | obj,
|  | unsigned int | index ) const

inline virtual

Reimplemented from osgDB::VectorBaseSerializer.

References OBJECT_CAST.

## getElement() [2/2]

template<typename C>

virtual void * osgDB::IsAVectorSerializer< C >::getElement | ( | osg::Object & | obj,
|  | unsigned int | index ) const

inline virtual

Reimplemented from osgDB::VectorBaseSerializer.

References OBJECT_CAST.

## getName()

template<typename C>

virtual const std::string & osgDB::IsAVectorSerializer< C >::getName | ( |  | ) | const

inline virtual

Implements osgDB::BaseSerializer.

References _name.

## insertElement()

template<typename C>

virtual void osgDB::IsAVectorSerializer< C >::insertElement | ( | osg::Object & | obj,
|  | unsigned int | index,
|  | void * | ptr ) const

inline virtual

Reimplemented from osgDB::VectorBaseSerializer.

References OBJECT_CAST.

## read()

template<typename C>

virtual bool osgDB::IsAVectorSerializer< C >::read | ( | InputStream & | is,
|  | osg::Object & | obj )

inline virtual

Implements osgDB::BaseSerializer.

References _name, osgDB::InputStream::BEGIN_BRACKET, osgDB::InputStream::END_BRACKET, osgDB::InputStream::isBinary(), osgDB::InputStream::matchString(), OBJECT_CAST, and size().

## reserve()

template<typename C>

virtual void osgDB::IsAVectorSerializer< C >::reserve | ( | osg::Object & | obj,
|  | unsigned int | numElements ) const

inline virtual

Reimplemented from osgDB::VectorBaseSerializer.

References OBJECT_CAST.

## resize()

template<typename C>

virtual void osgDB::IsAVectorSerializer< C >::resize | ( | osg::Object & | obj,
|  | unsigned int | numElements ) const

inline virtual

Reimplemented from osgDB::VectorBaseSerializer.

References OBJECT_CAST.

## setElement()

template<typename C>

virtual void osgDB::IsAVectorSerializer< C >::setElement | ( | osg::Object & | obj,
|  | unsigned int | index,
|  | void * | ptr ) const

inline virtual

Reimplemented from osgDB::VectorBaseSerializer.

References OBJECT_CAST.

## size()

template<typename C>

virtual unsigned int osgDB::IsAVectorSerializer< C >::size | ( | const osg::Object & | obj | ) | const

inline virtual

Reimplemented from osgDB::VectorBaseSerializer.

References OBJECT_CAST.

Referenced by read(), and write().

## write()

template<typename C>

virtual bool osgDB::IsAVectorSerializer< C >::write | ( | OutputStream & | os,
|  | const osg::Object & | obj )

inline virtual

Implements osgDB::BaseSerializer.

References _name, _numElementsOnRow, osgDB::OutputStream::BEGIN_BRACKET, osgDB::OutputStream::END_BRACKET, osgDB::OutputStream::isBinary(), OBJECT_CAST, osgDB::OutputStream::PROPERTY, and size().

## Member Data Documentation

## _name

template<typename C>

std::string osgDB::IsAVectorSerializer< C >::_name

Referenced by getName(), IsAVectorSerializer(), read(), and write().

## _numElementsOnRow

template<typename C>

unsigned int osgDB::IsAVectorSerializer< C >::_numElementsOnRow

Referenced by IsAVectorSerializer(), and write().

The documentation for this class was generated from the following file:

- Serializer